



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Windows内核编程之：分页内存与非分页内存 #define PAGEDCODE code_seg(&quot;PAGE&quot;) （转）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Windows内核编程之：分页内存与非分页内存 #define PAGEDCODE code_seg(&quot;PAGE&quot;) （转）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 05:00:52 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>
<p>原文链接：http://blog.chinaunix.net/uid-24504987-id-161192.html</p>
<p>Windows规定有些虚拟内存可以交换到文件中，这类内存被称为<strong>分页内存</strong></p>
<p>有些虚拟内存永远不会交换到文件中，这些内存叫<strong>非分页内存</strong></p>
<p>#define PAGEDCODE &nbsp;code_seg(&ldquo;PAGE&rdquo;);//分页内存</p>
<p>#define LOCKEDCODE &nbsp;code_seg();//非分页的</p>
<p>#define INITCODE &nbsp;code_seg(&ldquo;INIT&rdquo;);</p>
<p>#define PAGEDDATA&nbsp; data_seg(&ldquo;PAGE&rdquo;);</p>
<p>#define LOCKEDDATA&nbsp; data_seg();</p>
<p>#define INITDATA&nbsp; data_seg(&ldquo;INIT&rdquo;);</p>
<p><strong>例：</strong></p>
<p>如果将某个函数载入到分页内存中，可用下列的函数</p>
<p>#pragma PAGEDCODE</p>
<p>VOID Fun()</p>
<p>{</p>
<p>　　PAGED_CODE(); //do something</p>
<p>}</p>
<p><strong>注意：</strong>&nbsp;&nbsp; PAGED_CODE()是DDK提供的宏，只在check版本中生效，它会检查这个函数是否运行在低于DISPATCH_LEVAL的中断请求，如果等于或高于这个中断请求级，则产生一个断言。当程序运行在DISPATCH_LEVEL之上时（包括本层），程序只能使用非分页内存，否则将导致蓝屏死机</p>
<p>如果将某个函数载入到非分页内存中，可用下列的函数</p>
<p>#pragma LOCKEDCODE</p>
<p>VOID　Fun()</p>
<p>{</p>
<p>}</p>
<p>某个例程需要在初始化的时候载入内存，然后可以从内存中卸载掉，比如 DriverEntry 情况下，DriverEntry会很大，占据很大的空间，为了节省内存，需要及时地从内存中卸载</p>
<p>#pragma INITCODE</p>
<p>NTSTATUS DriverEntry(</p>
<p>IN PDRIVER_OBJECT pDriverObject,</p>
<p>IN PUNICODE_STRING RegisterPath)</p>
<p>{//do something&nbsp; }</p></div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9j7w095.html">spring boot&lpar;六&rpar;：如何优雅的使用mybatis</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv3p4y8.html">&lbrack;moka同学笔记&rsqb;MySql语句整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlpy569.html">SharePoint 判断用户是否在字段&amp;quot&semi;人员和组&amp;quot&semi;里面</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlx3oeq.html">javascript中的链表结构&mdash;双向链表</a>
		</li>
						<li><a href="https://www.batexi.com/a/39035gj9.html">&lbrack;&lbrack;4&rsqb;&comma; &lbrack;5&comma; 6&comma; 7&rsqb;&rsqb;（Python）list的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmy6vl9.html">自己写的demo。List&amp;lt&semi;HashMap&amp;lt&semi;String&comma;Object&amp;gt&semi;&amp;gt&semi;&equals;new ArrayList&amp;lt&semi;HashMap&amp;lt&semi;String&comma;Object&amp;gt&semi;&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0okz4q.html">iBox v2&period;0 发布，Web化仿iOS7界面&sol;交互的JavaScirpt库</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmwm709.html">akka简单示例-2</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmg2e19.html">jar包和war包的区别：</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zp36e9.html">VB   ListBox 添加横向滚动条</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj4dml8.html">js系列教程1-数组操作全解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz67mw8.html">idea中，发现某个java语法在低版本中不支持时的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpyx559.html">SQLServer之修改FOREIGN KEY约束</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kek6z9.html">MaxCompute教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2v1x0q.html">Java中强、软、弱、虚引用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjv1pl9.html">ODBC是什么</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5rp7eq.html">P3813 &lbrack;FJOI2017&rsqb;矩阵填数（组合数学）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn753dq.html">OPCache使用示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk6kn18.html">&commat;valid注解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk6zk18.html">【笔记】JS数据类型总结</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96ol1yy9.html">python 知识 rstrip&comma;strip&comma;lstrip</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmzl049.html">C&num;的历史及IDE总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmrerl9.html">hdu 4291 A Short problem</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oz0739.html">Android中如何取消调转界面后EditText默认获取聚焦问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x73nm8.html">Protected Functions 是理解OO的难点和关键</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmp1ge9.html">atomikos的Jta配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj2pz49.html">nchar 和 nvarchar</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmr3kl9.html">IE Web 开发支持将迁移到 StackOverflow</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oz70v9.html">php&sol; java&sol;asp&period;net</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y3nknq.html">Redpine Signals RS9110－N－11－02 Wi－Fi解决方案</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
